/*
	File:		MesaRenderer.cc

	Function:	

	Author:		Andrew Willmott

	Notes:		
*/

#include "gcl/MesaRenderer.h"

#ifdef GCL_MESA

Void MesaRenderer::Init(RGBAImage &img)
{
	mesaContext = OSMesaCreateContext(OSMESA_RGBA, 0);
	
	glWidth = img.Width();
	glHeight = img.Height();
	outImage = &img;

	MakeCurrent();
	
	GLRenderer::Init();
}

Void MesaRenderer::MakeCurrent()
{
	// it seems as if calling this twice core dumps?
	// so... how else do we switch between it and other
	// contexts? I guess we don't.
	if (!OSMesaMakeCurrent(mesaContext, outImage->RGBAData(),
		GL_UNSIGNED_BYTE, outImage->Width(), outImage->Height()))
		_Error("Couldn't select mesa context");
}

MesaRenderer::~MesaRenderer()
{
	OSMesaDestroyContext(mesaContext);
}

#endif
