#include "SomeScenes.h"
#include "arg.h"

int main(int argc, char **argv)
{
	Int size;
	Int tcomplex, scomplex, rcomplex, complex, bounce, tube;
	Int chairs = 9;
	Int lights = 1;
	
	if (arg_parse(argc, argv, 
			"", 										"usage: prog [options]",
			
			"-complex", ARG_FLAG(&complex),					"",
			"-rcomplex", ARG_FLAG(&rcomplex),				"",
			"-scomplex", ARG_FLAG(&scomplex),				"",
			"-tcomplex", ARG_FLAG(&tcomplex),				"",
			"-bounce", ARG_FLAG(&bounce),					"",
			"-tube", ARG_FLAG(&tube),						"",
			"-size", ARG_FLAG(&size),						"",
			"-chairs %d", &chairs,							"",
			"-lights %d", &lights,							"",
						
			0) < 0)
		return(1);

	if (tube)
		cout << TubeScene();
	if (bounce)
		cout << MultiBounce(size);
	else if (complex)
		cout <<  ComplexityScene(chairs,lights);
	else if (rcomplex)
		cout <<  RComplexityScene(chairs);
	else if (scomplex)
		cout <<  SComplexityScene(chairs);
	else if (tcomplex)
		cout <<  TComplexityScene(chairs);
	else
		cout << "No scene specified!" << endl;
		
	return(0);
}
