/*
	File:			ProgRad.h

	Function:		Provides a class for lighting a scene using progressive 
					radiosity.
					
	Author(s):		Andrew Willmott

	Copyright:		(c) 1997-2000, Andrew Willmott
 */

#ifndef __ProgRad__
#define __ProgRad__

#include "RadMethod.h"

class ProgRad : public RadMethod
{
public:
	Bool		Render();				
	Int			Stage(Int stage);		
	RadElem		*NewMesh();

	Void		DrawMatrix(Renderer &r);
	Void		DumpStats();
	
	Void		MakeFormFactorFromVector(RadElem &fromPatch, PatchList &patches,
					ColourList &result);

	ColourList	B;						// Radiosity of scene elements
	ColourList	S;						// Unshot radiosities
	
	Int			maxPowerIndex;			
				// index of patch with largest unshot power
	GCLReal		error, maxPower, origShoot;
	Colour		envRad;
				// Ambient radiosity.
	Int			iterations;
	
	ColourList	FFRow;	 		// Row of form factors * reflectance for R, G, B

#ifdef RAD_VIS
	Array<ColourList>
				FFRows;	// previous rows for matrix display
#endif

	static Void	*New() { return(new ProgRad); };
};

#endif
