//
//	File:       WaveCoeffs.cc   (auto-generated by MTE.cc)
//
//	Purpose:    Contains coefficients useful for wavelet/galerkin radiosity
//
//	Author:     Andrew Willmott, (c) 1996-1997
//

// === Quad (Tensor) Push/Pull Matrices =======================================

const Mat2d M2_LINEC_P0(
        1.0, -0.5, 
        0.0, 0.5
    );

const Mat2d M2_LINEC_P1(
        1.0, 0.5, 
        0.0, 0.5
    );

const Mat2d M2_LINEC_L0(
        0.5, 0.5, 
        0.0, 1.0
    );

const Mat2d M2_LINEC_L1(
        0.5, -0.5, 
        0.0, 1.0
    );


const Mat2d M2_LINE_P0(
        1.0, 0.0, 
        0.0, 0.5
    );

const Mat2d M2_LINE_P1(
        1.0, 0.5, 
        0.0, 0.5
    );

const Mat2d M2_LINE_L0(
        0.5, 0.0, 
        0.0, 1.0
    );

const Mat2d M2_LINE_L1(
        0.5, -0.5, 
        0.0, 1.0
    );


const Mat2d F2_LINE_P0(
        1.25, -0.25, 
        0.75, 0.25
    );

const Mat2d F2_LINE_P1(
        0.25, 0.75, 
        -0.25, 1.25
    );

const Mat2d F2_LINE_L0(
        0.25, 0.25, 
        -0.75, 1.25
    );

const Mat2d F2_LINE_L1(
        1.25, -0.75, 
        0.25, 0.25
    );


const Mat3d M3_LINE_P0(
        1.0, 0.0, -0.25, 
        0.0, 0.5, 0.0, 
        0.0, 0.0, 0.25
    );

const Mat3d M3_LINE_P1(
        1.0, 0.5, 0.0, 
        0.0, 0.5, 0.5, 
        0.0, 0.0, 0.25
    );

const Mat3d M3_LINE_L0(
        0.5, 0.0, 0.5, 
        0.0, 1.0, 0.0, 
        0.0, 0.0, 2.0
    );

const Mat3d M3_LINE_L1(
        0.5, -0.5, 1.0, 
        0.0, 1.0, -2, 
        0.0, 0.0, 2.0
    );


const Mat3d F3_LINE_P0(
        1.375, -0.5, 0.125, 
        0.625, 0.5, -0.125, 
        0.125, 1.0, -0.125
    );

const Mat3d F3_LINE_P1(
        -0.125, 1.0, 0.125, 
        -0.125, 0.5, 0.625, 
        0.125, -0.5, 1.375
    );

const Mat3d F3_LINE_L0(
        0.25, 0.25, 0.0, 
        0.25, -0.75, 1.0, 
        2.25, -5.75, 4.0
    );

const Mat3d F3_LINE_L1(
        4.0, -5.75, 2.25, 
        1.0, -0.75, 0.25, 
        0.0, 0.25, 0.25
    );


// === Quad (Tensor) Transfer Matrices ========================================

const Mat2d M2_LINE_R(
        1.36603, -0.366025, 
        -1.73205, 1.73205
    );

const Mat2d M2_LINE_S(
        0.5, 0.105662, 
        0.5, 0.394338
    );


const Mat3d M3_LINE_R(
        2.58994, -2.88889, 1.29895, 
        -4.62433, 6.66667, -2.04234, 
        3.33333, -6.66667, 3.33333
    );

const Mat3d M3_LINE_S(
        0.277778, 0.031306, -0.0890644, 
        0.444444, 0.222222, -0.037037, 
        0.277778, 0.246472, 0.126101
    );


const Mat2d MCC2_LINE_R(
        1.5, -0.5, 
        -2, 2.0
    );

const Mat2d MCC2_LINE_S(
        1.0, 0.25, 
        1.0, 0.75
    );


const Mat3d MCC3_LINE_R(
        3.33333, -4.16667, 1.83333, 
        -6, 9.0, -3, 
        4.5, -9, 4.5
    );

const Mat3d MCC3_LINE_S(
        1.0, 0.166667, -0.296296, 
        1.0, 0.5, -0.0740741, 
        1.0, 0.833333, 0.37037
    );


const Matd M2_QUAD_U(4, 2, 
        0.211325, 0.211325, 
        0.788675, 0.211325, 
        0.211325, 0.788675, 
        0.788675, 0.788675
    );

const Matd M3_QUAD_U(9, 2, 
        0.112702, 0.112702, 
        0.5, 0.112702, 
        0.887298, 0.112702, 
        0.112702, 0.5, 
        0.5, 0.5, 
        0.887298, 0.5, 
        0.112702, 0.887298, 
        0.5, 0.887298, 
        0.887298, 0.887298
    );


// === Triangular Push/Pull Matrices ==========================================

const Mat3d M2_TRI_P0(
        1.0, 0.0, 0.0, 
        0.5, 0.5, 0.0, 
        0.5, 0.0, 0.5
    );

const Mat3d M2_TRI_P1(
        0.5, 0.5, 0.0, 
        0.0, 1.0, 0.0, 
        0.0, 0.5, 0.5
    );

const Mat3d M2_TRI_P2(
        0.5, 0.0, 0.5, 
        0.0, 0.5, 0.5, 
        0.0, 0.0, 1.0
    );

const Mat3d M2_TRI_P3(
        0.0, 0.5, 0.5, 
        0.5, 0.0, 0.5, 
        0.5, 0.5, 0.0
    );

const Mat3d M2_TRI_L0(
        0.25, 0.0, 0.0, 
        -0.25, 0.5, 0.0, 
        -0.25, 0.0, 0.5
    );

const Mat3d M2_TRI_L1(
        0.5, -0.25, 0.0, 
        0.0, 0.25, 0.0, 
        0.0, -0.25, 0.5
    );

const Mat3d M2_TRI_L2(
        0.5, 0.0, -0.25, 
        0.0, 0.5, -0.25, 
        0.0, 0.0, 0.25
    );

const Mat3d M2_TRI_L3(
        -0.25, 0.25, 0.25, 
        0.25, -0.25, 0.25, 
        0.25, 0.25, -0.25
    );


const Mat4d F2_TRI_P0(
        1.6875, 0.1875, 0.1875, -1.0625, 
        0.6875, 0.1875, -0.3125, 0.4375, 
        0.6875, -0.3125, 0.1875, 0.4375, 
        0.9375, -0.0625, -0.0625, 0.1875
    );

const Mat4d F2_TRI_P1(
        0.1875, 0.6875, -0.3125, 0.4375, 
        0.1875, 1.6875, 0.1875, -1.0625, 
        -0.3125, 0.6875, 0.1875, 0.4375, 
        -0.0625, 0.9375, -0.0625, 0.1875
    );

const Mat4d F2_TRI_P2(
        0.1875, -0.3125, 0.6875, 0.4375, 
        -0.3125, 0.1875, 0.6875, 0.4375, 
        0.1875, 0.1875, 1.6875, -1.0625, 
        -0.0625, -0.0625, 0.9375, 0.1875
    );

const Mat4d F2_TRI_P3(
        -0.3125, 0.1875, 0.1875, 0.9375, 
        0.1875, -0.3125, 0.1875, 0.9375, 
        0.1875, 0.1875, -0.3125, 0.9375, 
        -0.0625, -0.0625, -0.0625, 1.1875
    );

const Mat4d F2_TRI_L0(
        0.0625, 0.0625, 0.0625, 0.0625, 
        0.5625, 1.5625, 1.0625, -2.9375, 
        0.5625, 1.0625, 1.5625, -2.9375, 
        0.0625, 0.5625, 0.5625, -0.9375
    );

const Mat4d F2_TRI_L1(
        1.5625, 0.5625, 1.0625, -2.9375, 
        0.0625, 0.0625, 0.0625, 0.0625, 
        1.0625, 0.5625, 1.5625, -2.9375, 
        0.5625, 0.0625, 0.5625, -0.9375
    );

const Mat4d F2_TRI_L2(
        1.5625, 1.0625, 0.5625, -2.9375, 
        1.0625, 1.5625, 0.5625, -2.9375, 
        0.0625, 0.0625, 0.0625, 0.0625, 
        0.5625, 0.5625, 0.0625, -0.9375
    );

const Mat4d F2_TRI_L3(
        0.0625, 0.5625, 0.5625, -0.9375, 
        0.5625, 0.0625, 0.5625, -0.9375, 
        0.5625, 0.5625, 0.0625, -0.9375, 
        0.0625, 0.0625, 0.0625, 0.0625
    );


const Matd M3_TRI_P0(6, 6, 
        1.0, 0.0, 0.0, 0.0, 0.0, 0.0, 
        0.25, 0.25, 0.0, 0.5, 0.0, 0.0, 
        0.25, 0.0, 0.25, 0.0, 0.0, 0.5, 
        0.5, 0.0, 0.0, 0.5, 0.0, 0.0, 
        0.25, 0.0, 0.0, 0.25, 0.25, 0.25, 
        0.5, 0.0, 0.0, 0.0, 0.0, 0.5
    );

const Matd M3_TRI_P1(6, 6, 
        0.25, 0.25, 0.0, 0.5, 0.0, 0.0, 
        0.0, 1.0, 0.0, 0.0, 0.0, 0.0, 
        0.0, 0.25, 0.25, 0.0, 0.5, 0.0, 
        0.0, 0.5, 0.0, 0.5, 0.0, 0.0, 
        0.0, 0.5, 0.0, 0.0, 0.5, 0.0, 
        0.0, 0.25, 0.0, 0.25, 0.25, 0.25
    );

const Matd M3_TRI_P2(6, 6, 
        0.25, 0.0, 0.25, 0.0, 0.0, 0.5, 
        0.0, 0.25, 0.25, 0.0, 0.5, 0.0, 
        0.0, 0.0, 1.0, 0.0, 0.0, 0.0, 
        0.0, 0.0, 0.25, 0.25, 0.25, 0.25, 
        0.0, 0.0, 0.5, 0.0, 0.5, 0.0, 
        0.0, 0.0, 0.5, 0.0, 0.0, 0.5
    );

const Matd M3_TRI_P3(6, 6, 
        0.0, 0.25, 0.25, 0.0, 0.5, 0.0, 
        0.25, 0.0, 0.25, 0.0, 0.0, 0.5, 
        0.25, 0.25, 0.0, 0.5, 0.0, 0.0, 
        0.0, 0.0, 0.25, 0.25, 0.25, 0.25, 
        0.25, 0.0, 0.0, 0.25, 0.25, 0.25, 
        0.0, 0.25, 0.0, 0.25, 0.25, 0.25
    );

const Matd M3_TRI_L0(6, 6, 
        0.25, 0.0, 0.0, 0.0, 0.0, 0.0, 
        0.25, 1.0, 0.0, -1, 0.0, 0.0, 
        0.25, 0.0, 1.0, 0.0, 0.0, -1, 
        -0.25, 0.0, 0.0, 0.5, 0.0, 0.0, 
        0.25, 0.0, 0.0, -0.5, 1.0, -0.5, 
        -0.25, 0.0, 0.0, 0.0, 0.0, 0.5
    );

const Matd M3_TRI_L1(6, 6, 
        1.0, 0.25, 0.0, -1, 0.0, 0.0, 
        0.0, 0.25, 0.0, 0.0, 0.0, 0.0, 
        0.0, 0.25, 1.0, 0.0, -1, 0.0, 
        0.0, -0.25, 0.0, 0.5, 0.0, 0.0, 
        0.0, -0.25, 0.0, 0.0, 0.5, 0.0, 
        0.0, 0.25, 0.0, -0.5, -0.5, 1.0
    );

const Matd M3_TRI_L2(6, 6, 
        1.0, 0.0, 0.25, 0.0, 0.0, -1, 
        0.0, 1.0, 0.25, 0.0, -1, 0.0, 
        0.0, 0.0, 0.25, 0.0, 0.0, 0.0, 
        0.0, 0.0, 0.25, 1.0, -0.5, -0.5, 
        0.0, 0.0, -0.25, 0.0, 0.5, 0.0, 
        0.0, 0.0, -0.25, 0.0, 0.0, 0.5
    );

const Matd M3_TRI_L3(6, 6, 
        0.25, 0.25, 0.25, -0.5, 0.5, -0.5, 
        0.25, 0.25, 0.25, -0.5, -0.5, 0.5, 
        0.25, 0.25, 0.25, 0.5, -0.5, -0.5, 
        -0.25, -0.25, 0.25, 0.5, 0.0, 0.0, 
        0.25, -0.25, -0.25, 0.0, 0.5, 0.0, 
        -0.25, 0.25, -0.25, 0.0, 0.0, 0.5
    );


const Matd F3_TRI_P0(9, 9, 
        1.91667, -0.427083, -0.114583, -0.427083, -0.583333, 0.822917, -0.114583, 0.822917, -0.895833, 
        0.59375, 0.90625, 0.125, -0.375, 0.28125, -0.9375, -0.03125, 0.15625, 0.28125, 
        0.104167, 1.57292, 0.0729167, 0.0104167, 0.354167, -0.864583, 0.0104167, -0.177083, -0.0833333, 
        0.59375, -0.375, -0.03125, 0.90625, 0.28125, 0.15625, 0.125, -0.9375, 0.28125, 
        -0.0625, -0.125, 0.0, -0.125, -0.0625, 0.0625, 0.0, 0.0625, 1.25, 
        0.114583, 0.645833, 0.0520833, -0.260417, 0.177083, -0.510417, 0.0208333, -0.0416667, 0.802083, 
        0.104167, 0.0104167, 0.0104167, 1.57292, 0.354167, -0.177083, 0.0729167, -0.864583, -0.0833333, 
        0.114583, -0.260417, 0.0208333, 0.645833, 0.177083, -0.0416667, 0.0520833, -0.510417, 0.802083, 
        0.895833, -0.104167, 0.0208333, -0.104167, 0.0208333, -0.0416667, 0.0208333, -0.0416667, 0.333333
    );

const Matd F3_TRI_P1(9, 9, 
        0.0729167, 1.57292, 0.104167, 0.354167, 0.0104167, -0.0833333, 0.0104167, -0.177083, -0.864583, 
        0.125, 0.90625, 0.59375, 0.28125, -0.375, 0.28125, -0.03125, 0.15625, -0.9375, 
        -0.114583, -0.427083, 1.91667, -0.583333, -0.427083, -0.895833, -0.114583, 0.822917, 0.822917, 
        0.0, -0.125, -0.0625, -0.0625, -0.125, 1.25, 0.0, 0.0625, 0.0625, 
        -0.03125, -0.375, 0.59375, 0.28125, 0.90625, 0.28125, 0.125, -0.9375, 0.15625, 
        0.0208333, -0.104167, 0.895833, 0.0208333, -0.104167, 0.333333, 0.0208333, -0.0416667, -0.0416667, 
        0.0104167, 0.0104167, 0.104167, 0.354167, 1.57292, -0.0833333, 0.0729167, -0.864583, -0.177083, 
        0.0208333, -0.260417, 0.114583, 0.177083, 0.645833, 0.802083, 0.0520833, -0.510417, -0.0416667, 
        0.0520833, 0.645833, 0.114583, 0.177083, -0.260417, 0.802083, 0.0208333, -0.0416667, -0.510417
    );

const Matd F3_TRI_P2(9, 9, 
        0.0729167, 0.354167, 0.0104167, 1.57292, 0.0104167, -0.177083, 0.104167, -0.0833333, -0.864583, 
        0.0, -0.0625, 0.0, -0.125, -0.125, 0.0625, -0.0625, 1.25, 0.0625, 
        0.0104167, 0.354167, 0.0729167, 0.0104167, 1.57292, -0.864583, 0.104167, -0.0833333, -0.177083, 
        0.125, 0.28125, -0.03125, 0.90625, -0.375, 0.15625, 0.59375, 0.28125, -0.9375, 
        -0.03125, 0.28125, 0.125, -0.375, 0.90625, -0.9375, 0.59375, 0.28125, 0.15625, 
        0.0208333, 0.177083, 0.0520833, -0.260417, 0.645833, -0.510417, 0.114583, 0.802083, -0.0416667, 
        -0.114583, -0.583333, -0.114583, -0.427083, -0.427083, 0.822917, 1.91667, -0.895833, 0.822917, 
        0.0208333, 0.0208333, 0.0208333, -0.104167, -0.104167, -0.0416667, 0.895833, 0.333333, -0.0416667, 
        0.0520833, 0.177083, 0.0208333, 0.645833, -0.260417, -0.0416667, 0.114583, 0.802083, -0.510417
    );

const Matd F3_TRI_P3(9, 9, 
        0.0208333, -0.0416667, -0.0416667, -0.0416667, 0.895833, 0.145833, -0.0416667, 0.145833, -0.0416667, 
        -0.0729167, -0.291667, -0.0729167, -0.260417, -0.260417, 0.489583, -0.166667, 1.14583, 0.489583, 
        -0.0416667, -0.0416667, 0.0208333, 0.895833, -0.0416667, -0.0416667, -0.0416667, 0.145833, 0.145833, 
        -0.0729167, -0.260417, -0.166667, -0.291667, -0.260417, 1.14583, -0.0729167, 0.489583, 0.489583, 
        -0.166667, -0.260417, -0.0729167, -0.260417, -0.291667, 0.489583, -0.0729167, 0.489583, 1.14583, 
        -0.135417, -0.322917, -0.0416667, -0.0416667, -0.322917, 0.395833, -0.135417, 0.802083, 0.802083, 
        -0.0416667, 0.895833, -0.0416667, -0.0416667, -0.0416667, 0.145833, 0.0208333, -0.0416667, 0.145833, 
        -0.135417, -0.0416667, -0.135417, -0.322917, -0.322917, 0.802083, -0.0416667, 0.395833, 0.802083, 
        -0.0416667, -0.322917, -0.135417, -0.322917, -0.0416667, 0.802083, -0.135417, 0.802083, 0.395833
    );

const Matd F3_TRI_L0(9, 9, 
        0.0625, 0.0625, 0.0, 0.0625, 0.0, 0.0, 0.0, 0.0, 0.0625, 
        -0.229167, -0.104167, 0.708333, 0.0208333, 0.958333, -1.29167, 0.0833333, -0.666667, 0.770833, 
        -4.1875, -0.9375, 6.75, -2.6875, 8.25, -17.25, 0.5, -4, 13.8125, 
        -0.229167, 0.0208333, 0.0833333, -0.104167, 0.958333, -0.666667, 0.708333, -1.29167, 0.770833, 
        -2.85417, 5.52083, 2.45833, 5.52083, 14.5833, -15.2917, 2.45833, -15.2917, 3.14583, 
        -1.64583, 1.60417, 2.41667, 1.72917, 7.04167, -8.83333, 0.791667, -6.20833, 3.35417, 
        -4.1875, -2.6875, 0.5, -0.9375, 8.25, -4, 6.75, -17.25, 13.8125, 
        -1.64583, 1.72917, 0.791667, 1.60417, 7.04167, -6.20833, 2.41667, -8.83333, 3.35417, 
        -0.0208333, 0.104167, 0.0416667, 0.104167, 0.416667, -0.208333, 0.0416667, -0.208333, -0.0208333
    );

const Matd F3_TRI_L1(9, 9, 
        6.75, -0.9375, -4.1875, 8.25, -2.6875, 13.8125, 0.5, -4, -17.25, 
        0.708333, -0.104167, -0.229167, 0.958333, 0.0208333, 0.770833, 0.0833333, -0.666667, -1.29167, 
        0.0, 0.0625, 0.0625, 0.0, 0.0625, 0.0625, 0.0, 0.0, 0.0, 
        2.45833, 5.52083, -2.85417, 14.5833, 5.52083, 3.14583, 2.45833, -15.2917, -15.2917, 
        0.0833333, 0.0208333, -0.229167, 0.958333, -0.104167, 0.770833, 0.708333, -1.29167, -0.666667, 
        0.0416667, 0.104167, -0.0208333, 0.416667, 0.104167, -0.0208333, 0.0416667, -0.208333, -0.208333, 
        0.5, -2.6875, -4.1875, 8.25, -0.9375, 13.8125, 6.75, -17.25, -4, 
        0.791667, 1.72917, -1.64583, 7.04167, 1.60417, 3.35417, 2.41667, -8.83333, -6.20833, 
        2.41667, 1.60417, -1.64583, 7.04167, 1.72917, 3.35417, 0.791667, -6.20833, -8.83333
    );

const Matd F3_TRI_L2(9, 9, 
        6.75, 8.25, 0.5, -0.9375, -2.6875, -4, -4.1875, 13.8125, -17.25, 
        2.45833, 14.5833, 2.45833, 5.52083, 5.52083, -15.2917, -2.85417, 3.14583, -15.2917, 
        0.5, 8.25, 6.75, -2.6875, -0.9375, -17.25, -4.1875, 13.8125, -4, 
        0.708333, 0.958333, 0.0833333, -0.104167, 0.0208333, -0.666667, -0.229167, 0.770833, -1.29167, 
        0.0833333, 0.958333, 0.708333, 0.0208333, -0.104167, -1.29167, -0.229167, 0.770833, -0.666667, 
        0.791667, 7.04167, 2.41667, 1.72917, 1.60417, -8.83333, -1.64583, 3.35417, -6.20833, 
        0.0, 0.0, 0.0, 0.0625, 0.0625, 0.0, 0.0625, 0.0625, 0.0, 
        0.0416667, 0.416667, 0.0416667, 0.104167, 0.104167, -0.208333, -0.0208333, -0.0208333, -0.208333, 
        2.41667, 7.04167, 0.791667, 1.60417, 1.72917, -6.20833, -1.64583, 3.35417, -8.83333
    );

const Matd F3_TRI_L3(9, 9, 
        -1.39583, 3.04167, 1.35417, 3.04167, 8.29167, -8.39583, 1.35417, -8.39583, 1.35417, 
        -0.0208333, 0.0416667, -0.0208333, 0.166667, 0.166667, -0.0208333, 0.354167, -0.395833, -0.0208333, 
        1.35417, 3.04167, -1.39583, 8.29167, 3.04167, 1.35417, 1.35417, -8.39583, -8.39583, 
        -0.0208333, 0.166667, 0.354167, 0.0416667, 0.166667, -0.395833, -0.0208333, -0.0208333, -0.0208333, 
        0.354167, 0.166667, -0.0208333, 0.166667, 0.0416667, -0.0208333, -0.0208333, -0.0208333, -0.395833, 
        0.229167, 0.416667, -0.145833, 1.54167, 0.416667, 0.104167, 0.229167, -1.27083, -1.27083, 
        1.35417, 8.29167, 1.35417, 3.04167, 3.04167, -8.39583, -1.39583, 1.35417, -8.39583, 
        0.229167, 1.54167, 0.229167, 0.416667, 0.416667, -1.27083, -0.145833, 0.104167, -1.27083, 
        -0.145833, 0.416667, 0.229167, 0.416667, 1.54167, -1.27083, 0.229167, -1.27083, 0.104167
    );


// === Triangular Transfer Matrices ==========================================

const Mat3d M2_TRI_R(
        1.66667, -0.333333, -0.333333, 
        -0.333333, -0.333333, 1.66667, 
        -0.333333, 1.66667, -0.333333
    );

const Mat3d M2_TRI_S(
        0.222222, 0.0555556, 0.0555556, 
        0.0555556, 0.0555556, 0.222222, 
        0.0555556, 0.222222, 0.0555556
    );


const Matd M3_TRI_R(6, 7, 
        -0.9, 1.93751, 0.106559, 0.106559, 0.362493, -0.306559, -0.306559, 
        -0.9, 0.106559, 0.106559, 1.93751, -0.306559, -0.306559, 0.362493, 
        -0.9, 0.106559, 1.93751, 0.106559, -0.306559, 0.362493, -0.306559, 
        1.35, -0.808915, 0.22284, -0.808915, -0.641085, 2.32716, -0.641085, 
        1.35, 0.22284, -0.808915, -0.808915, 2.32716, -0.641085, -0.641085, 
        1.35, -0.808915, -0.808915, 0.22284, -0.641085, -0.641085, 2.32716
    );

const Matd M3_TRI_S(7, 6, 
        0.025, 0.025, 0.025, 0.05, 0.05, 0.05, 
        0.0800834, 0.001292, 0.001292, 0.0203439, 0.00258401, 0.0203439, 
        0.001292, 0.001292, 0.0800834, 0.00258401, 0.0203439, 0.0203439, 
        0.001292, 0.0800834, 0.001292, 0.0203439, 0.0203439, 0.00258401, 
        0.000472116, 0.0292636, 0.0292636, 0.00743392, 0.0585271, 0.00743392, 
        0.0292636, 0.0292636, 0.000472116, 0.0585271, 0.00743392, 0.00743392, 
        0.0292636, 0.000472116, 0.0292636, 0.00743392, 0.00743392, 0.0585271
    );


const Matd MCC2_TRI_R(3, 4, 
        1.58333, -0.416667, -0.416667, 0.25, 
        -0.416667, 1.58333, -0.416667, 0.25, 
        -0.416667, -0.416667, 1.58333, 0.25
    );

const Matd MCC2_TRI_S(4, 3, 
        0.666667, 0.166667, 0.166667, 
        0.166667, 0.666667, 0.166667, 
        0.166667, 0.166667, 0.666667, 
        0.333333, 0.333333, 0.333333
    );


const Matd MCC3_TRI_R(6, 9, 
        2.13384, -0.627525, 0.224747, -0.627525, 0.463384, -0.354798, 0.224747, -0.354798, -0.0820707, 
        0.224747, -0.627525, 2.13384, 0.463384, -0.627525, -0.0820707, 0.224747, -0.354798, -0.354798, 
        0.224747, 0.463384, 0.224747, -0.627525, -0.627525, -0.354798, 2.13384, -0.0820707, -0.354798, 
        -1.13889, 2.98611, -1.13889, -0.763889, -0.763889, 0.736111, 0.361111, -0.0138889, 0.736111, 
        0.361111, -0.763889, -1.13889, -0.763889, 2.98611, 0.736111, -1.13889, 0.736111, -0.0138889, 
        -1.13889, -0.763889, 0.361111, 2.98611, -0.763889, -0.0138889, -1.13889, 0.736111, 0.736111
    );

const Matd MCC3_TRI_S(9, 6, 
        0.611111, 0.0185185, 0.0185185, 0.166667, 0.0185185, 0.166667, 
        0.203704, 0.203704, 0.0185185, 0.388889, 0.0925926, 0.0925926, 
        0.0185185, 0.611111, 0.0185185, 0.166667, 0.166667, 0.0185185, 
        0.203704, 0.0185185, 0.203704, 0.0925926, 0.0925926, 0.388889, 
        0.0185185, 0.203704, 0.203704, 0.0925926, 0.388889, 0.0925926, 
        0.0555556, 0.314815, 0.0555556, 0.240741, 0.240741, 0.0925926, 
        0.0185185, 0.0185185, 0.611111, 0.0185185, 0.166667, 0.166667, 
        0.0555556, 0.0555556, 0.314815, 0.0925926, 0.240741, 0.240741, 
        0.314815, 0.0555556, 0.0555556, 0.240741, 0.0925926, 0.240741
    );


const Matd M2_TRI_U(3, 2, 
        0.166667, 0.166667, 
        0.166667, 0.666667, 
        0.666667, 0.166667
    );

const Matd M3_TRI_U(7, 2, 
        0.333333, 0.333333, 
        0.101287, 0.101287, 
        0.101287, 0.797427, 
        0.797427, 0.101287, 
        0.470142, 0.470142, 
        0.470142, 0.0597159, 
        0.0597159, 0.470142
    );

const Matd M2_QUAD_EU(4, 2, 
        1.0, 1.0, 
        0.0, 1.0, 
        1.0, 0.0, 
        0.0, 0.0
    );

const Mat4d M2_QUAD_E(
        0.133975, -0.5, -0.5, 1.86603, 
        -0.5, 0.133975, 1.86603, -0.5, 
        -0.5, 1.86603, 0.133975, -0.5, 
        1.86603, -0.5, -0.5, 0.133975
    );

const Matd M3_QUAD_EU(4, 2, 
        1.0, 1.0, 
        0.0, 1.0, 
        1.0, 0.0, 
        0.0, 0.0
    );

const Matd M3_QUAD_E(4, 9, 
        0.0352824, -0.125224, 0.277778, -0.125224, 0.444444, -0.985887, 0.277778, -0.985887, 2.18694, 
        0.277778, -0.125224, 0.0352824, -0.985887, 0.444444, -0.125224, 2.18694, -0.985887, 0.277778, 
        0.277778, -0.985887, 2.18694, -0.125224, 0.444444, -0.985887, 0.0352824, -0.125224, 0.277778, 
        2.18694, -0.985887, 0.277778, -0.985887, 0.444444, -0.125224, 0.277778, -0.125224, 0.0352824
    );

const Matd M2_TRI_EU(4, 2, 
        0.0, 1.0, 
        0.33333, 0.33333, 
        0.0, 0.0, 
        1.0, 0.0
    );

const Matd M2_TRI_E(4, 3, 
        -0.333333, 1.66667, -0.333333, 
        0.333347, 0.333327, 0.333327, 
        1.66667, -0.333333, -0.333333, 
        -0.333333, -0.333333, 1.66667
    );

const Matd M3_TRI_EU(4, 2, 
        0.0, 1.0, 
        0.33333, 0.33333, 
        0.0, 0.0, 
        1.0, 0.0
    );

const Matd M3_TRI_E(4, 7, 
        -0.9, 0.106559, 1.93751, 0.106559, -0.306559, 0.362493, -0.306559, 
        0.6, -0.0710359, -0.0710412, -0.0710412, 0.204363, 0.204378, 0.204378, 
        -0.9, 1.93751, 0.106559, 0.106559, 0.362493, -0.306559, -0.306559, 
        -0.9, 0.106559, 0.106559, 1.93751, -0.306559, -0.306559, 0.362493
    );

